# WWW::SwaggerClient::AttributeApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::AttributeApi;
```

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_attribute**](AttributeApi.md#create_attribute) | **POST** /attributes | creates a new attribute
[**delete_attribute**](AttributeApi.md#delete_attribute) | **DELETE** /lists/{lid}/attributes/{id} | delete the attribute
[**get_attributes**](AttributeApi.md#get_attributes) | **GET** /lists/{lid}/attributes | get all Attributes of selected list
[**update_attribute**](AttributeApi.md#update_attribute) | **PATCH** /attributes/{id} | update the attribute


# **create_attribute**
> ApiResponsePost create_attribute(attribute => $attribute)

creates a new attribute

creates a new attribute.

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::AttributeApi->new();
my $attribute = WWW::SwaggerClient::Object::AttributePost->new(); # AttributePost | the data to save

eval { 
    my $result = $api_instance->create_attribute(attribute => $attribute);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AttributeApi->create_attribute: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **attribute** | [**AttributePost**](AttributePost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_attribute**
> ApiResponseDelete delete_attribute(lid => $lid, id => $id)

delete the attribute

delete one attribute

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::AttributeApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $id = 'id_example'; # string | the id of the attribute

eval { 
    my $result = $api_instance->delete_attribute(lid => $lid, id => $id);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AttributeApi->delete_attribute: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **id** | **string**| the id of the attribute | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_attributes**
> AttributeResponse get_attributes(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all Attributes of selected list

get Attributes

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::AttributeApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_attributes(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AttributeApi->get_attributes: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**AttributeResponse**](AttributeResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_attribute**
> PatchResponse update_attribute(id => $id, attribute => $attribute)

update the attribute

update one attribute

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::AttributeApi->new();
my $id = 'id_example'; # string | the id of the attribute
my $attribute = WWW::SwaggerClient::Object::AttributePatch->new(); # AttributePatch | the data to update

eval { 
    my $result = $api_instance->update_attribute(id => $id, attribute => $attribute);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AttributeApi->update_attribute: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the attribute | 
 **attribute** | [**AttributePatch**](AttributePatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

