# WWW::SwaggerClient::CompanyApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::CompanyApi;
```

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_company**](CompanyApi.md#get_company) | **GET** /companies | get the details of a company
[**update_company**](CompanyApi.md#update_company) | **PATCH** /companies/{id} | update the Company


# **get_company**
> CompanyResponse get_company()

get the details of a company

get the details of a company

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::CompanyApi->new();

eval { 
    my $result = $api_instance->get_company();
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling CompanyApi->get_company: $@\n";
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**CompanyResponse**](CompanyResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_company**
> PatchResponse update_company(id => $id, company => $company)

update the Company

update the Company

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::CompanyApi->new();
my $id = 'id_example'; # string | the id of the Company
my $company = WWW::SwaggerClient::Object::CompanyPatch->new(); # CompanyPatch | the data to update

eval { 
    my $result = $api_instance->update_company(id => $id, company => $company);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling CompanyApi->update_company: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the Company | 
 **company** | [**CompanyPatch**](CompanyPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

