# WWW::SwaggerClient::GroupApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::GroupApi;
```

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**add_recipient_to_group**](GroupApi.md#add_recipient_to_group) | **POST** /lists/{lid}/groups/{gid}/recipients/{id} | add single recipient to group
[**add_recipients_to_group**](GroupApi.md#add_recipients_to_group) | **POST** /lists/{lid}/groups/{gid}/recipients | add all Recipients to the given group
[**create_group**](GroupApi.md#create_group) | **POST** /groups | creates a new group
[**delete_group**](GroupApi.md#delete_group) | **DELETE** /groups/{id} | delete the Group
[**get_groups**](GroupApi.md#get_groups) | **GET** /lists/{lid}/groups | get all Group of selected list
[**get_recipients_by_group**](GroupApi.md#get_recipients_by_group) | **GET** /lists/{lid}/groups/{gid}/recipients | get all Recipients of selected group
[**remove_recipient_from_group**](GroupApi.md#remove_recipient_from_group) | **DELETE** /lists/{lid}/groups/{gid}/recipients/{id} | remove single recipient from group
[**remove_recipients_from_group**](GroupApi.md#remove_recipients_from_group) | **DELETE** /lists/{lid}/groups/{gid}/recipients | remove all Recipients from given group
[**update_group**](GroupApi.md#update_group) | **PATCH** /groups/{id} | update the Group


# **add_recipient_to_group**
> PatchResponse add_recipient_to_group(lid => $lid, gid => $gid, id => $id)

add single recipient to group

add Recipient to Group

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $gid = 'gid_example'; # string | the id of the group
my $id = 'id_example'; # string | the id of the recipient

eval { 
    my $result = $api_instance->add_recipient_to_group(lid => $lid, gid => $gid, id => $id);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->add_recipient_to_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **gid** | **string**| the id of the group | 
 **id** | **string**| the id of the recipient | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_recipients_to_group**
> PatchResponse add_recipients_to_group(lid => $lid, gid => $gid, _filter => $_filter)

add all Recipients to the given group

add all Recipients to the given group. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting added to the group!

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $gid = 'gid_example'; # string | the id of the group
my $_filter = '_filter_example'; # string | a FIQL-Filter

eval { 
    my $result = $api_instance->add_recipients_to_group(lid => $lid, gid => $gid, _filter => $_filter);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->add_recipients_to_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **gid** | **string**| the id of the group | 
 **_filter** | **string**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_group**
> ApiResponsePost create_group(group => $group)

creates a new group

creates a new group.

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $group = WWW::SwaggerClient::Object::GroupPost->new(); # GroupPost | the data to save

eval { 
    my $result = $api_instance->create_group(group => $group);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->create_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **group** | [**GroupPost**](GroupPost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_group**
> ApiResponseDelete delete_group(id => $id)

delete the Group

delete one Group

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $id = 'id_example'; # string | the id of the Group

eval { 
    my $result = $api_instance->delete_group(id => $id);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->delete_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the Group | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_groups**
> GroupResponse get_groups(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all Group of selected list

get Groups

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_groups(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->get_groups: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**GroupResponse**](GroupResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recipients_by_group**
> RecipientResponse get_recipients_by_group(lid => $lid, gid => $gid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all Recipients of selected group

get Recipients

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $gid = 'gid_example'; # string | the id of the group
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_recipients_by_group(lid => $lid, gid => $gid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->get_recipients_by_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **gid** | **string**| the id of the group | 
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**RecipientResponse**](RecipientResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipient_from_group**
> PatchResponse remove_recipient_from_group(lid => $lid, gid => $gid, id => $id)

remove single recipient from group

remove Recipient to Group

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $gid = 'gid_example'; # string | the id of the group
my $id = 'id_example'; # string | the id of the recipient

eval { 
    my $result = $api_instance->remove_recipient_from_group(lid => $lid, gid => $gid, id => $id);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->remove_recipient_from_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **gid** | **string**| the id of the group | 
 **id** | **string**| the id of the recipient | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipients_from_group**
> PatchResponse remove_recipients_from_group(lid => $lid, gid => $gid, _filter => $_filter)

remove all Recipients from given group

remove all Recipients from given group. Pay attention to the filter, if you forget to submit it, all recipients are getting removed from the group!

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $gid = 'gid_example'; # string | the id of the group
my $_filter = '_filter_example'; # string | a FIQL-Filter

eval { 
    my $result = $api_instance->remove_recipients_from_group(lid => $lid, gid => $gid, _filter => $_filter);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->remove_recipients_from_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **gid** | **string**| the id of the group | 
 **_filter** | **string**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_group**
> PatchResponse update_group(id => $id, group => $group)

update the Group

update one Group

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::GroupApi->new();
my $id = 'id_example'; # string | the id of the Group
my $group = WWW::SwaggerClient::Object::GroupPatch->new(); # GroupPatch | the data to update

eval { 
    my $result = $api_instance->update_group(id => $id, group => $group);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling GroupApi->update_group: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the Group | 
 **group** | [**GroupPatch**](GroupPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

