# WWW::SwaggerClient::ListApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::ListApi;
```

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_list**](ListApi.md#create_list) | **POST** /lists | creates a new list
[**delete_list**](ListApi.md#delete_list) | **DELETE** /lists/{id} | delete the List
[**get_lists**](ListApi.md#get_lists) | **GET** /lists | get all lists
[**get_recipients**](ListApi.md#get_recipients) | **GET** /lists/{lid}/recipients | get all Recipients of selected list
[**remove_recipients_from_list**](ListApi.md#remove_recipients_from_list) | **DELETE** /lists/{lid}/recipients | remove all Recipients from selected list
[**update_list**](ListApi.md#update_list) | **PATCH** /lists/{id} | update the List
[**update_recipients**](ListApi.md#update_recipients) | **PATCH** /lists/{lid}/recipients | update all Recipients in selected list


# **create_list**
> ApiResponsePost create_list(list => $list)

creates a new list

creates a new List

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $list = WWW::SwaggerClient::Object::ListPost->new(); # ListPost | the data to save

eval { 
    my $result = $api_instance->create_list(list => $list);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->create_list: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **list** | [**ListPost**](ListPost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_list**
> ApiResponseDelete delete_list(id => $id)

delete the List

delete one List

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $id = 'id_example'; # string | the id of the list

eval { 
    my $result = $api_instance->delete_list(id => $id);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->delete_list: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the list | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_lists**
> ListResponse get_lists(_filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all lists

get Lists

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_lists(_filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->get_lists: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**ListResponse**](ListResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recipients**
> RecipientResponse get_recipients(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all Recipients of selected list

Get Recipients. If the API shall return custom attributes also, submit them in the _fields-Parameter by name.

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_recipients(lid => $lid, _filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->get_recipients: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**RecipientResponse**](RecipientResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipients_from_list**
> PatchResponse remove_recipients_from_list(lid => $lid, _filter => $_filter)

remove all Recipients from selected list

remove Recipients from selected list. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting removed!

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $_filter = '_filter_example'; # string | a FIQL-Filter

eval { 
    my $result = $api_instance->remove_recipients_from_list(lid => $lid, _filter => $_filter);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->remove_recipients_from_list: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **_filter** | **string**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_list**
> PatchResponse update_list(id => $id, list => $list)

update the List

update one List

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $id = 'id_example'; # string | the id of the list
my $list = WWW::SwaggerClient::Object::ListPost->new(); # ListPost | the data to update

eval { 
    my $result = $api_instance->update_list(id => $id, list => $list);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->update_list: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the list | 
 **list** | [**ListPost**](ListPost.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_recipients**
> PatchResponse update_recipients(lid => $lid, _filter => $_filter)

update all Recipients in selected list

Updates all recipients in the given list where the filter applies. If a value of a custom attribute shall by changed just submit it in the json body. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting updated!

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::ListApi->new();
my $lid = 'lid_example'; # string | the id of the list
my $_filter = '_filter_example'; # string | a FIQL-Filter

eval { 
    my $result = $api_instance->update_recipients(lid => $lid, _filter => $_filter);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ListApi->update_recipients: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **string**| the id of the list | 
 **_filter** | **string**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

