# WWW::SwaggerClient::UserApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::UserApi;
```

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_users**](UserApi.md#get_users) | **GET** /users | get all users of the company where the current user has access to
[**update_user**](UserApi.md#update_user) | **PATCH** /users/{id} | update the user


# **get_users**
> UserResponse get_users(_filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields)

get all users of the company where the current user has access to

get Users

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::UserApi->new();
my $_filter = '_filter_example'; # string | a FIQL-Filter
my $_limit = 56; # int | a limit for list-responses
my $_offset = 56; # int | an offset for list-responses
my $_expand = 1; # boolean | true if attributes should be returned or not
my $_fields = (); # ARRAY[string] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed

eval { 
    my $result = $api_instance->get_users(_filter => $_filter, _limit => $_limit, _offset => $_offset, _expand => $_expand, _fields => $_fields);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling UserApi->get_users: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_filter** | **string**| a FIQL-Filter | [optional] 
 **_limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **_offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **_expand** | **boolean**| true if attributes should be returned or not | [optional] 
 **_fields** | [**ARRAY[string]**](string.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**UserResponse**](UserResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_user**
> PatchResponse update_user(id => $id, user => $user)

update the user

update one user

### Example 
```perl
use Data::Dumper;

# Configure OAuth2 access token for authorization: OAuth
$WWW::SwaggerClient::Configuration::access_token = 'YOUR_ACCESS_TOKEN';

my $api_instance = WWW::SwaggerClient::UserApi->new();
my $id = 'id_example'; # string | the id of the user
my $user = WWW::SwaggerClient::Object::UserPatch->new(); # UserPatch | the data to update

eval { 
    my $result = $api_instance->update_user(id => $id, user => $user);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling UserApi->update_user: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| the id of the user | 
 **user** | [**UserPatch**](UserPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

