#
# Copyright 2016 SmartBear Software
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
#
package WWW::SwaggerClient::AttributeApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# create_attribute
#
# creates a new attribute
# 
# @param AttributePost $attribute the data to save (required)
{
    my $params = {
    'attribute' => {
        data_type => 'AttributePost',
        description => 'the data to save',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ create_attribute } = { 
    	summary => 'creates a new attribute',
        params => $params,
        returns => 'ApiResponsePost',
        };
}
# @return ApiResponsePost
#
sub create_attribute {
    my ($self, %args) = @_;

    # verify the required parameter 'attribute' is set
    unless (exists $args{'attribute'}) {
      croak("Missing the required parameter 'attribute' when calling create_attribute");
    }

    # parse inputs
    my $_resource_path = '/attributes';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'attribute'}) {
        $_body_data = $args{'attribute'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ApiResponsePost', $response);
    return $_response_object;
}

#
# delete_attribute
#
# delete the attribute
# 
# @param string $lid the id of the list (required)
# @param string $id the id of the attribute (required)
{
    my $params = {
    'lid' => {
        data_type => 'string',
        description => 'the id of the list',
        required => '1',
    },
    'id' => {
        data_type => 'string',
        description => 'the id of the attribute',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ delete_attribute } = { 
    	summary => 'delete the attribute',
        params => $params,
        returns => 'ApiResponseDelete',
        };
}
# @return ApiResponseDelete
#
sub delete_attribute {
    my ($self, %args) = @_;

    # verify the required parameter 'lid' is set
    unless (exists $args{'lid'}) {
      croak("Missing the required parameter 'lid' when calling delete_attribute");
    }

    # verify the required parameter 'id' is set
    unless (exists $args{'id'}) {
      croak("Missing the required parameter 'id' when calling delete_attribute");
    }

    # parse inputs
    my $_resource_path = '/lists/{lid}/attributes/{id}';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'lid'}) {
        my $_base_variable = "{" . "lid" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'lid'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'id'}) {
        my $_base_variable = "{" . "id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ApiResponseDelete', $response);
    return $_response_object;
}

#
# get_attributes
#
# get all Attributes of selected list
# 
# @param string $lid the id of the list (required)
# @param string $_filter a FIQL-Filter (optional)
# @param int $_limit a limit for list-responses (optional, default to 50)
# @param int $_offset an offset for list-responses (optional, default to 0)
# @param boolean $_expand true if attributes should be returned or not (optional)
# @param ARRAY[string] $_fields list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
{
    my $params = {
    'lid' => {
        data_type => 'string',
        description => 'the id of the list',
        required => '1',
    },
    '_filter' => {
        data_type => 'string',
        description => 'a FIQL-Filter',
        required => '0',
    },
    '_limit' => {
        data_type => 'int',
        description => 'a limit for list-responses',
        required => '0',
    },
    '_offset' => {
        data_type => 'int',
        description => 'an offset for list-responses',
        required => '0',
    },
    '_expand' => {
        data_type => 'boolean',
        description => 'true if attributes should be returned or not',
        required => '0',
    },
    '_fields' => {
        data_type => 'ARRAY[string]',
        description => 'list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ get_attributes } = { 
    	summary => 'get all Attributes of selected list',
        params => $params,
        returns => 'AttributeResponse',
        };
}
# @return AttributeResponse
#
sub get_attributes {
    my ($self, %args) = @_;

    # verify the required parameter 'lid' is set
    unless (exists $args{'lid'}) {
      croak("Missing the required parameter 'lid' when calling get_attributes");
    }

    # parse inputs
    my $_resource_path = '/lists/{lid}/attributes';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'_filter'}) {
        $query_params->{'_filter'} = $self->{api_client}->to_query_value($args{'_filter'});
    }

    # query params
    if ( exists $args{'_limit'}) {
        $query_params->{'_limit'} = $self->{api_client}->to_query_value($args{'_limit'});
    }

    # query params
    if ( exists $args{'_offset'}) {
        $query_params->{'_offset'} = $self->{api_client}->to_query_value($args{'_offset'});
    }

    # query params
    if ( exists $args{'_expand'}) {
        $query_params->{'_expand'} = $self->{api_client}->to_query_value($args{'_expand'});
    }

    # query params
    if ( exists $args{'_fields'}) {
        $query_params->{'_fields'} = $self->{api_client}->to_query_value($args{'_fields'});
    }

    # path params
    if ( exists $args{'lid'}) {
        my $_base_variable = "{" . "lid" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'lid'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('AttributeResponse', $response);
    return $_response_object;
}

#
# update_attribute
#
# update the attribute
# 
# @param string $id the id of the attribute (required)
# @param AttributePatch $attribute the data to update (required)
{
    my $params = {
    'id' => {
        data_type => 'string',
        description => 'the id of the attribute',
        required => '1',
    },
    'attribute' => {
        data_type => 'AttributePatch',
        description => 'the data to update',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ update_attribute } = { 
    	summary => 'update the attribute',
        params => $params,
        returns => 'PatchResponse',
        };
}
# @return PatchResponse
#
sub update_attribute {
    my ($self, %args) = @_;

    # verify the required parameter 'id' is set
    unless (exists $args{'id'}) {
      croak("Missing the required parameter 'id' when calling update_attribute");
    }

    # verify the required parameter 'attribute' is set
    unless (exists $args{'attribute'}) {
      croak("Missing the required parameter 'attribute' when calling update_attribute");
    }

    # parse inputs
    my $_resource_path = '/attributes/{id}';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'PATCH';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'id'}) {
        my $_base_variable = "{" . "id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'attribute'}) {
        $_body_data = $args{'attribute'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PatchResponse', $response);
    return $_response_object;
}

1;
