#
# Copyright 2016 SmartBear Software
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
#
package WWW::SwaggerClient::AuthorizationApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# get_token
#
# Endpoint for retrieving a token
# 
# @param string $grant_type grant_type (required)
# @param string $username username. Required for grant_type https://nl2go.com/jwt (optional)
# @param string $password password. Required for grant_type https://nl2go.com/jwt (optional)
# @param string $refresh_token refresh_token. Required for grant_type https://nl2go.com/jwt_refresh (optional)
{
    my $params = {
    'grant_type' => {
        data_type => 'string',
        description => 'grant_type',
        required => '1',
    },
    'username' => {
        data_type => 'string',
        description => 'username. Required for grant_type https://nl2go.com/jwt',
        required => '0',
    },
    'password' => {
        data_type => 'string',
        description => 'password. Required for grant_type https://nl2go.com/jwt',
        required => '0',
    },
    'refresh_token' => {
        data_type => 'string',
        description => 'refresh_token. Required for grant_type https://nl2go.com/jwt_refresh',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ get_token } = { 
    	summary => 'Endpoint for retrieving a token',
        params => $params,
        returns => 'Token',
        };
}
# @return Token
#
sub get_token {
    my ($self, %args) = @_;

    # verify the required parameter 'grant_type' is set
    unless (exists $args{'grant_type'}) {
      croak("Missing the required parameter 'grant_type' when calling get_token");
    }

    # parse inputs
    my $_resource_path = '/oauth/v2/token';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'username'} ) {
                $form_params->{'username'} = $self->{api_client}->to_form_value($args{'username'});
    }
    
    # form params
    if ( exists $args{'password'} ) {
                $form_params->{'password'} = $self->{api_client}->to_form_value($args{'password'});
    }
    
    # form params
    if ( exists $args{'refresh_token'} ) {
                $form_params->{'refresh_token'} = $self->{api_client}->to_form_value($args{'refresh_token'});
    }
    
    # form params
    if ( exists $args{'grant_type'} ) {
                $form_params->{'grant_type'} = $self->{api_client}->to_form_value($args{'grant_type'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(Basic )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Token', $response);
    return $_response_object;
}

1;
