package WWW::SwaggerClient::Object::CompanyGet;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
#NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
#

__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'CompanyGet',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'id' => {
    	datatype => 'string',
    	base_name => 'id',
    	description => 'the id of the company',
    	format => '',
    	read_only => '',
    		},
    'name' => {
    	datatype => 'string',
    	base_name => 'name',
    	description => 'name of the company',
    	format => '',
    	read_only => '',
    		},
    'address' => {
    	datatype => 'string',
    	base_name => 'address',
    	description => 'the address of the company',
    	format => '',
    	read_only => '',
    		},
    'city' => {
    	datatype => 'string',
    	base_name => 'city',
    	description => 'the city of the company',
    	format => '',
    	read_only => '',
    		},
    'postcode' => {
    	datatype => 'string',
    	base_name => 'postcode',
    	description => 'the city of the company',
    	format => '',
    	read_only => '',
    		},
    'country' => {
    	datatype => 'string',
    	base_name => 'country',
    	description => 'the ISO 3166-1 alpha-2 country code of the company',
    	format => '',
    	read_only => '',
    		},
    'bill_name' => {
    	datatype => 'string',
    	base_name => 'bill_name',
    	description => 'name of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_first_name' => {
    	datatype => 'string',
    	base_name => 'bill_first_name',
    	description => 'first name of the contact person of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_last_name' => {
    	datatype => 'string',
    	base_name => 'bill_last_name',
    	description => 'last name of the contact person of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_address' => {
    	datatype => 'string',
    	base_name => 'bill_address',
    	description => 'the address of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_city' => {
    	datatype => 'string',
    	base_name => 'bill_city',
    	description => 'the city of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_postcode' => {
    	datatype => 'string',
    	base_name => 'bill_postcode',
    	description => 'the city of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'bill_country' => {
    	datatype => 'string',
    	base_name => 'bill_country',
    	description => 'the ISO 3166-1 alpha-2 country code of the company for bills',
    	format => '',
    	read_only => '',
    		},
    'default_list_id' => {
    	datatype => 'string',
    	base_name => 'default_list_id',
    	description => 'the id of the list which should be used as default',
    	format => '',
    	read_only => '',
    		},
    'state' => {
    	datatype => 'string',
    	base_name => 'state',
    	description => 'the state of the company (allowed to send or not)',
    	format => '',
    	read_only => '',
    		},
    'credits_email' => {
    	datatype => 'int',
    	base_name => 'credits_email',
    	description => 'the amount of prepaid credits',
    	format => '',
    	read_only => '',
    		},
    'credits_freemail' => {
    	datatype => 'int',
    	base_name => 'credits_freemail',
    	description => 'the number of free credits',
    	format => '',
    	read_only => '',
    		},
    'credits_abo' => {
    	datatype => 'int',
    	base_name => 'credits_abo',
    	description => 'the number of abo credits',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'id' => 'string',
    'name' => 'string',
    'address' => 'string',
    'city' => 'string',
    'postcode' => 'string',
    'country' => 'string',
    'bill_name' => 'string',
    'bill_first_name' => 'string',
    'bill_last_name' => 'string',
    'bill_address' => 'string',
    'bill_city' => 'string',
    'bill_postcode' => 'string',
    'bill_country' => 'string',
    'default_list_id' => 'string',
    'state' => 'string',
    'credits_email' => 'int',
    'credits_freemail' => 'int',
    'credits_abo' => 'int'
} );

__PACKAGE__->attribute_map( {
    'id' => 'id',
    'name' => 'name',
    'address' => 'address',
    'city' => 'city',
    'postcode' => 'postcode',
    'country' => 'country',
    'bill_name' => 'bill_name',
    'bill_first_name' => 'bill_first_name',
    'bill_last_name' => 'bill_last_name',
    'bill_address' => 'bill_address',
    'bill_city' => 'bill_city',
    'bill_postcode' => 'bill_postcode',
    'bill_country' => 'bill_country',
    'default_list_id' => 'default_list_id',
    'state' => 'state',
    'credits_email' => 'credits_email',
    'credits_freemail' => 'credits_freemail',
    'credits_abo' => 'credits_abo'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
