package WWW::SwaggerClient::Object::NewsletterPost;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
#NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
#

__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'NewsletterPost',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'type' => {
    	datatype => 'string',
    	base_name => 'type',
    	description => 'the type of newsletter',
    	format => '',
    	read_only => '',
    		},
    'name' => {
    	datatype => 'string',
    	base_name => 'name',
    	description => 'a name for the newsletter',
    	format => '',
    	read_only => '',
    		},
    'description' => {
    	datatype => 'string',
    	base_name => 'description',
    	description => 'a description for the newsletter',
    	format => '',
    	read_only => '',
    		},
    'has_open_tracking' => {
    	datatype => 'boolean',
    	base_name => 'has_open_tracking',
    	description => 'weither open_tracking is enabled or not',
    	format => '',
    	read_only => '',
    		},
    'has_click_tracking' => {
    	datatype => 'boolean',
    	base_name => 'has_click_tracking',
    	description => 'weither click_tracking is enabled or not',
    	format => '',
    	read_only => '',
    		},
    'has_conversion_tracking' => {
    	datatype => 'boolean',
    	base_name => 'has_conversion_tracking',
    	description => 'weither click_tracking is enabled or not',
    	format => '',
    	read_only => '',
    		},
    'json' => {
    	datatype => 'string',
    	base_name => 'json',
    	description => 'the json-description of the content.',
    	format => '',
    	read_only => '',
    		},
    'html' => {
    	datatype => 'string',
    	base_name => 'html',
    	description => 'the html content of the newsletter. Is needed when json is not submitted. Otherwise html is optional and will override the html generated out of the json.',
    	format => '',
    	read_only => '',
    		},
    'text' => {
    	datatype => 'string',
    	base_name => 'text',
    	description => 'the text content of the newsletter. If submitted, it will overwrite the automatically generated text-version out of json/html',
    	format => '',
    	read_only => '',
    		},
    'subject' => {
    	datatype => 'string',
    	base_name => 'subject',
    	description => 'the subject of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'preheader' => {
    	datatype => 'string',
    	base_name => 'preheader',
    	description => 'the preheader of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'header_reply_email' => {
    	datatype => 'string',
    	base_name => 'header_reply_email',
    	description => 'the reply email send in the header of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'header_reply_name' => {
    	datatype => 'string',
    	base_name => 'header_reply_name',
    	description => 'the reply name send in the header of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'header_from_email' => {
    	datatype => 'string',
    	base_name => 'header_from_email',
    	description => 'the from email send in the header of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'header_from_name' => {
    	datatype => 'string',
    	base_name => 'header_from_name',
    	description => 'the from name send in the header of the newsletter',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'type' => 'string',
    'name' => 'string',
    'description' => 'string',
    'has_open_tracking' => 'boolean',
    'has_click_tracking' => 'boolean',
    'has_conversion_tracking' => 'boolean',
    'json' => 'string',
    'html' => 'string',
    'text' => 'string',
    'subject' => 'string',
    'preheader' => 'string',
    'header_reply_email' => 'string',
    'header_reply_name' => 'string',
    'header_from_email' => 'string',
    'header_from_name' => 'string'
} );

__PACKAGE__->attribute_map( {
    'type' => 'type',
    'name' => 'name',
    'description' => 'description',
    'has_open_tracking' => 'has_open_tracking',
    'has_click_tracking' => 'has_click_tracking',
    'has_conversion_tracking' => 'has_conversion_tracking',
    'json' => 'json',
    'html' => 'html',
    'text' => 'text',
    'subject' => 'subject',
    'preheader' => 'preheader',
    'header_reply_email' => 'header_reply_email',
    'header_reply_name' => 'header_reply_name',
    'header_from_email' => 'header_from_email',
    'header_from_name' => 'header_from_name'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
