package WWW::SwaggerClient::Object::NewsletterSend;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
#NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
#

__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'NewsletterSend',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'scheduled' => {
    	datatype => 'string',
    	base_name => 'scheduled',
    	description => 'ISO8601 timestamp for defining when the newsletter shall be send. If not set, the newsletter will be send immediatly',
    	format => '',
    	read_only => '',
    		},
    'group_ids' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'group_ids',
    	description => 'a list of group ids to which the newsletter gets send (If neither group_ids nor recipient_ids are given, the newsletter gets send to the whole list)',
    	format => '',
    	read_only => '',
    		},
    'recipient_ids' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'recipient_ids',
    	description => 'a list of recipient_ids ids to which the newsletter gets send (If group_ids is given, recipient_ids are ignored. If neither group_ids nor recipient_ids are given, the newsletter gets send to the whole list)',
    	format => '',
    	read_only => '',
    		},
    'contexts' => {
    	datatype => 'ARRAY[object]',
    	base_name => 'contexts',
    	description => 'A list of contexts in which every context must have at least an email-address under recipient &lt;code&gt;{\&quot;recipient\&quot;:{\&quot;email\&quot;:\&quot;...\&quot;}}&lt;/code&gt;.&lt;br&gt;Contexts are only allowed for mailings of type transaction',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'scheduled' => 'string',
    'group_ids' => 'ARRAY[string]',
    'recipient_ids' => 'ARRAY[string]',
    'contexts' => 'ARRAY[object]'
} );

__PACKAGE__->attribute_map( {
    'scheduled' => 'scheduled',
    'group_ids' => 'group_ids',
    'recipient_ids' => 'recipient_ids',
    'contexts' => 'contexts'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
