package WWW::SwaggerClient::Object::RecipientGet;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
#NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
#

__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'RecipientGet',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'id' => {
    	datatype => 'string',
    	base_name => 'id',
    	description => 'the id of the recipient',
    	format => '',
    	read_only => '',
    		},
    'email' => {
    	datatype => 'string',
    	base_name => 'email',
    	description => 'the email of the recipient',
    	format => '',
    	read_only => '',
    		},
    'phone' => {
    	datatype => 'string',
    	base_name => 'phone',
    	description => 'the phone number of the recipient',
    	format => '',
    	read_only => '',
    		},
    'gender' => {
    	datatype => 'string',
    	base_name => 'gender',
    	description => 'm for male and f for female',
    	format => '',
    	read_only => '',
    		},
    'first_name' => {
    	datatype => 'string',
    	base_name => 'first_name',
    	description => 'the first name of the recipient',
    	format => '',
    	read_only => '',
    		},
    'last_name' => {
    	datatype => 'string',
    	base_name => 'last_name',
    	description => 'the last name of the recipient',
    	format => '',
    	read_only => '',
    		},
    'is_unsubscribed' => {
    	datatype => 'boolean',
    	base_name => 'is_unsubscribed',
    	description => 'weither the recipient is unsubscribed or not',
    	format => '',
    	read_only => '',
    		},
    'is_blacklisted' => {
    	datatype => 'boolean',
    	base_name => 'is_blacklisted',
    	description => 'weither the recipient is blacklisted or not',
    	format => '',
    	read_only => '',
    		},
    '_custom_attribute_' => {
    	datatype => 'string',
    	base_name => '_custom_attribute_',
    	description => 'every custom attribute can be submitted',
    	format => '',
    	read_only => '',
    		},
    'rating' => {
    	datatype => 'int',
    	base_name => 'rating',
    	description => 'Indicating the quality of the recipient. Between 0 and 5',
    	format => '',
    	read_only => '',
    		},
    'statistic_mails_received' => {
    	datatype => 'int',
    	base_name => 'statistic_mails_received',
    	description => 'how many newsletters the recipient has received',
    	format => '',
    	read_only => '',
    		},
    'statistic_mails_opened' => {
    	datatype => 'int',
    	base_name => 'statistic_mails_opened',
    	description => 'how many newsletters the recipient has opened',
    	format => '',
    	read_only => '',
    		},
    'statistic_mails_unique_opened' => {
    	datatype => 'int',
    	base_name => 'statistic_mails_unique_opened',
    	description => 'how many newsletters the recipient has uniqly opened',
    	format => '',
    	read_only => '',
    		},
    'statistic_mails_clicked' => {
    	datatype => 'int',
    	base_name => 'statistic_mails_clicked',
    	description => 'how often the recipient has clicked on links in newsletters',
    	format => '',
    	read_only => '',
    		},
    'statistic_conversions' => {
    	datatype => 'int',
    	base_name => 'statistic_conversions',
    	description => 'how often the recipient has converted',
    	format => '',
    	read_only => '',
    		},
    'statistic_conversions_sum' => {
    	datatype => 'double',
    	base_name => 'statistic_conversions_sum',
    	description => 'how much the recipient has spent',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_mail_action' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_mail_action',
    	description => 'when the recipient has had the last interaction with a newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_mail_received' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_mail_received',
    	description => 'when the recipient has had received the last newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_mail_opened' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_mail_opened',
    	description => 'when the recipient has had opened the last newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_mail_clicked' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_mail_clicked',
    	description => 'when the recipient has had clicked the last newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_mail_converted' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_mail_converted',
    	description => 'when the recipient has had converted the last time',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_useragent_device' => {
    	datatype => 'string',
    	base_name => 'statistic_last_useragent_device',
    	description => 'the last useragent device used for opening a newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_useragent_family' => {
    	datatype => 'string',
    	base_name => 'statistic_last_useragent_family',
    	description => 'the last useragent family used for opening a newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_latitude' => {
    	datatype => 'double',
    	base_name => 'statistic_last_latitude',
    	description => 'the last latitude where the recipient has opened a newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_longitude' => {
    	datatype => 'double',
    	base_name => 'statistic_last_longitude',
    	description => 'the last longitude where the recipient has opened a newsletter',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_blacklist_list' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_blacklist_list',
    	description => 'when the recipient was blacklisted the last time',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_unsubscribe_list' => {
    	datatype => 'DateTime',
    	base_name => 'statistic_last_unsubscribe_list',
    	description => 'when the recipient was unsubscribed the last time',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_blacklist_list_reason' => {
    	datatype => 'string',
    	base_name => 'statistic_last_blacklist_list_reason',
    	description => 'the reason the recipient got blacklisted the last time',
    	format => '',
    	read_only => '',
    		},
    'statistic_last_unsubscribe_list_reason' => {
    	datatype => 'string',
    	base_name => 'statistic_last_unsubscribe_list_reason',
    	description => 'the reason the recipient got unsubscribed the last time',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'id' => 'string',
    'email' => 'string',
    'phone' => 'string',
    'gender' => 'string',
    'first_name' => 'string',
    'last_name' => 'string',
    'is_unsubscribed' => 'boolean',
    'is_blacklisted' => 'boolean',
    '_custom_attribute_' => 'string',
    'rating' => 'int',
    'statistic_mails_received' => 'int',
    'statistic_mails_opened' => 'int',
    'statistic_mails_unique_opened' => 'int',
    'statistic_mails_clicked' => 'int',
    'statistic_conversions' => 'int',
    'statistic_conversions_sum' => 'double',
    'statistic_last_mail_action' => 'DateTime',
    'statistic_last_mail_received' => 'DateTime',
    'statistic_last_mail_opened' => 'DateTime',
    'statistic_last_mail_clicked' => 'DateTime',
    'statistic_last_mail_converted' => 'DateTime',
    'statistic_last_useragent_device' => 'string',
    'statistic_last_useragent_family' => 'string',
    'statistic_last_latitude' => 'double',
    'statistic_last_longitude' => 'double',
    'statistic_last_blacklist_list' => 'DateTime',
    'statistic_last_unsubscribe_list' => 'DateTime',
    'statistic_last_blacklist_list_reason' => 'string',
    'statistic_last_unsubscribe_list_reason' => 'string'
} );

__PACKAGE__->attribute_map( {
    'id' => 'id',
    'email' => 'email',
    'phone' => 'phone',
    'gender' => 'gender',
    'first_name' => 'first_name',
    'last_name' => 'last_name',
    'is_unsubscribed' => 'is_unsubscribed',
    'is_blacklisted' => 'is_blacklisted',
    '_custom_attribute_' => '_custom_attribute_',
    'rating' => 'rating',
    'statistic_mails_received' => 'statistic_mails_received',
    'statistic_mails_opened' => 'statistic_mails_opened',
    'statistic_mails_unique_opened' => 'statistic_mails_unique_opened',
    'statistic_mails_clicked' => 'statistic_mails_clicked',
    'statistic_conversions' => 'statistic_conversions',
    'statistic_conversions_sum' => 'statistic_conversions_sum',
    'statistic_last_mail_action' => 'statistic_last_mail_action',
    'statistic_last_mail_received' => 'statistic_last_mail_received',
    'statistic_last_mail_opened' => 'statistic_last_mail_opened',
    'statistic_last_mail_clicked' => 'statistic_last_mail_clicked',
    'statistic_last_mail_converted' => 'statistic_last_mail_converted',
    'statistic_last_useragent_device' => 'statistic_last_useragent_device',
    'statistic_last_useragent_family' => 'statistic_last_useragent_family',
    'statistic_last_latitude' => 'statistic_last_latitude',
    'statistic_last_longitude' => 'statistic_last_longitude',
    'statistic_last_blacklist_list' => 'statistic_last_blacklist_list',
    'statistic_last_unsubscribe_list' => 'statistic_last_unsubscribe_list',
    'statistic_last_blacklist_list_reason' => 'statistic_last_blacklist_list_reason',
    'statistic_last_unsubscribe_list_reason' => 'statistic_last_unsubscribe_list_reason'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
