package WWW::SwaggerClient::Object::Report;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
#NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
#

__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'Report',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'newsletter_id' => {
    	datatype => 'string',
    	base_name => 'newsletter_id',
    	description => 'the id of the newsletter',
    	format => '',
    	read_only => '',
    		},
    'date' => {
    	datatype => 'DateTime',
    	base_name => 'date',
    	description => 'the date of the aggregation',
    	format => '',
    	read_only => '',
    		},
    'mail_count' => {
    	datatype => 'int',
    	base_name => 'mail_count',
    	description => 'the number of recipients reached on this day',
    	format => '',
    	read_only => '',
    		},
    'opens' => {
    	datatype => 'int',
    	base_name => 'opens',
    	description => 'the number of opens on this day',
    	format => '',
    	read_only => '',
    		},
    'unique_opens' => {
    	datatype => 'int',
    	base_name => 'unique_opens',
    	description => 'the number of unique opens on this day',
    	format => '',
    	read_only => '',
    		},
    'clicks' => {
    	datatype => 'int',
    	base_name => 'clicks',
    	description => 'the number of clicks on this day',
    	format => '',
    	read_only => '',
    		},
    'unique_clicks' => {
    	datatype => 'int',
    	base_name => 'unique_clicks',
    	description => 'the number of unique clicks on this day',
    	format => '',
    	read_only => '',
    		},
    'conversions' => {
    	datatype => 'int',
    	base_name => 'conversions',
    	description => 'the number of conversions on this day',
    	format => '',
    	read_only => '',
    		},
    'sum_conversions' => {
    	datatype => 'int',
    	base_name => 'sum_conversions',
    	description => 'the amount recipients spent on this day',
    	format => '',
    	read_only => '',
    		},
    'unsubscribes' => {
    	datatype => 'int',
    	base_name => 'unsubscribes',
    	description => 'the number of unsubscribes on this day',
    	format => '',
    	read_only => '',
    		},
    'hard_bounces' => {
    	datatype => 'int',
    	base_name => 'hard_bounces',
    	description => 'the number of hard_bounces on this day',
    	format => '',
    	read_only => '',
    		},
    'soft_bounces' => {
    	datatype => 'int',
    	base_name => 'soft_bounces',
    	description => 'the number of soft_bounces on this day',
    	format => '',
    	read_only => '',
    		},
    'spam_bounces' => {
    	datatype => 'int',
    	base_name => 'spam_bounces',
    	description => 'the number of spam_bounces on this day',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'newsletter_id' => 'string',
    'date' => 'DateTime',
    'mail_count' => 'int',
    'opens' => 'int',
    'unique_opens' => 'int',
    'clicks' => 'int',
    'unique_clicks' => 'int',
    'conversions' => 'int',
    'sum_conversions' => 'int',
    'unsubscribes' => 'int',
    'hard_bounces' => 'int',
    'soft_bounces' => 'int',
    'spam_bounces' => 'int'
} );

__PACKAGE__->attribute_map( {
    'newsletter_id' => 'newsletter_id',
    'date' => 'date',
    'mail_count' => 'mail_count',
    'opens' => 'opens',
    'unique_opens' => 'unique_opens',
    'clicks' => 'clicks',
    'unique_clicks' => 'unique_clicks',
    'conversions' => 'conversions',
    'sum_conversions' => 'sum_conversions',
    'unsubscribes' => 'unsubscribes',
    'hard_bounces' => 'hard_bounces',
    'soft_bounces' => 'soft_bounces',
    'spam_bounces' => 'spam_bounces'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
