#
# Copyright 2016 SmartBear Software
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
#
package WWW::SwaggerClient::ReportApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# get_reports
#
# get reports for the newsletter aggregated by days
# 
# @param string $_filter a FIQL-Filter (optional)
# @param int $_limit a limit for list-responses (optional, default to 50)
# @param int $_offset an offset for list-responses (optional, default to 0)
# @param boolean $_expand true if attributes should be returned or not (optional)
# @param ARRAY[string] $_fields list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
{
    my $params = {
    '_filter' => {
        data_type => 'string',
        description => 'a FIQL-Filter',
        required => '0',
    },
    '_limit' => {
        data_type => 'int',
        description => 'a limit for list-responses',
        required => '0',
    },
    '_offset' => {
        data_type => 'int',
        description => 'an offset for list-responses',
        required => '0',
    },
    '_expand' => {
        data_type => 'boolean',
        description => 'true if attributes should be returned or not',
        required => '0',
    },
    '_fields' => {
        data_type => 'ARRAY[string]',
        description => 'list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ get_reports } = { 
    	summary => 'get reports for the newsletter aggregated by days',
        params => $params,
        returns => 'ReportResponse',
        };
}
# @return ReportResponse
#
sub get_reports {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/lists/{lid}/newsletters/{nid}/aggregations';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'_filter'}) {
        $query_params->{'_filter'} = $self->{api_client}->to_query_value($args{'_filter'});
    }

    # query params
    if ( exists $args{'_limit'}) {
        $query_params->{'_limit'} = $self->{api_client}->to_query_value($args{'_limit'});
    }

    # query params
    if ( exists $args{'_offset'}) {
        $query_params->{'_offset'} = $self->{api_client}->to_query_value($args{'_offset'});
    }

    # query params
    if ( exists $args{'_expand'}) {
        $query_params->{'_expand'} = $self->{api_client}->to_query_value($args{'_expand'});
    }

    # query params
    if ( exists $args{'_fields'}) {
        $query_params->{'_fields'} = $self->{api_client}->to_query_value($args{'_fields'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ReportResponse', $response);
    return $_response_object;
}

1;
